;---------------------------------------
; - Tento program demonstruje realizaci
;   8bitoveho D/A prevodniku pomoci
;   PWM (pulzni modulace) s frekvenci
;   asi 78kHz (pri 20MHz krystalu)
; - zdrojem signalu je integrovany
;   10bitovy A/D prevodnik
;---------------------------------------
	LIST	P = 16F877, R = DEC
	include	p16f877.inc

	__CONFIG	H'3F3A'
;---------------------------------------

	include	ad_prev.inc

OFFRAM	EQU	H'20'	; zacatek volne pameti "RAM"

#DEFINE	DAC_PIN	PORTC,2	; vystupni vyvod D/A prevodu

	CBLOCK	OFFRAM
	PWM_TEMP:1 ; pro zpracovani PWM vystupu

	ADTEMP:1	; pro A/D prevodnik
	ADRESL_:1
	ADRESH_:1
	AD_COUNT:1

	HODNOTA:1 ; vystup A/D prevodniku
	ENDC

;--------------------------------------

	ORG	0
	NOP	; 3x NOP kvuli zavadeci
	NOP
	NOP

	banksel	TRISA
	BCF	DAC_PIN
	MOVLW	B'00000000' ; zakladni nastaveni
	MOVWF	OPTION_REG
	banksel	T2CON	; nastaveni casovace pro PWM (preddelicka = 1:1)
	MOVLW	B'00000100'
	MOVWF	T2CON
	banksel	PR2
	MOVLW	D'63'	; 8bitovy vystup PWM - perioda TMR2 = 64 (*4)
	MOVWF	PR2
	MOVLW	B'10000100' ; nastaveni prevodniku
	MOVWF	ADCON1
	banksel	ADCON0
	MOVLW	B'10000001'
	MOVWF	ADCON0

	CLRF	TMR2	; nastaveni PWM a vynulovani faze (TMR2)
	CLRF	CCPR1L	; kanal CCP1
	MOVLW	B'00001100'
	MOVWF	CCP1CON

	CLRF	HODNOTA

OPAKUJ	MOVF	HODNOTA,W
	CALL	STRIDA	; nastaveni stridy PWM dle promenne HODNOTA

	MOVLW	D'3'	; provedeme A/D prevod na kanalu 3 (potenciometr P2)
	CALL	PREVOD
	banksel	ADRESH
	RRF	ADRESH,F
	banksel	ADRESL
	RRF	ADRESL,F
	banksel	ADRESH
	RRF	ADRESH,F
	banksel	ADRESL
	RRF	ADRESL,W
	banksel	HODNOTA
	MOVWF	HODNOTA

	GOTO	OPAKUJ	; opakujeme cely cyklus znovu

; realizace D/A prevodniku pomoci stridy PWM kanalu
STRIDA	MOVWF	PWM_TEMP	; zalohovani registru W
	RRF	PWM_TEMP,F
	BCF	CCP1CON,CCP1Y ; nasouvani nejnizsich bitu do CCP1Y a CCP1X
	BTFSC	STATUS,C
	BSF	CCP1CON,CCP1Y
	RRF	PWM_TEMP,W
	BCF	CCP1CON,CCP1X
	BTFSC	STATUS,C
	BSF	CCP1CON,CCP1X
	ANDLW	B'00111111' ; oriznuti smeti a zapis PWM_TEMP do hlavniho registru
	MOVWF	CCPR1L
	RETURN

	; A/D prevod
PREVOD	N_PREV	ADTEMP,ADRESL_,ADRESH_,AD_COUNT,D'0'

	END
