;------------------------------------------
; - Tento program demonstruje realizaci
;   10bitoveho D/A prevodniku pomoci
;   PWM (pulzni modulace) s frekvenci
;   asi 19kHz (pri 20MHz krystalu)
; - zdrojem signalu je integrovany
;   10bitovy A/D prevodnik
;------------------------------------------
	LIST	P = 16F877, R = DEC
	include	p16f877.inc

	__CONFIG	H'3F3A'
;--------------------------------------

	include	ad_prev.inc

OFFRAM	EQU	H'20'	; zacatek volne pameti "RAM"

#DEFINE	DAC_PIN	PORTC,2	; vystupni vyvod D/A prevodu

	CBLOCK	OFFRAM
	ADTEMP:1	; pro A/D prevod
	ADRESL_:1
	ADRESH_:1
	AD_COUNT:1

	HODNOTA:2 ; vystup A/D prevodniku
	ENDC

;--------------------------------------

	ORG	0
	NOP	; 3x NOP kvuli zavadeci
	NOP
	NOP

	banksel	TRISA
	BCF	DAC_PIN
	MOVLW	B'00000000' ; zakladni nastaveni
	MOVWF	OPTION_REG
	banksel	T2CON	; nastaveni casovace pro PWM (preddelicka = 1:1)
	MOVLW	B'00000100'
	MOVWF	T2CON
	banksel	PR2
	MOVLW	D'255'	; 10bitovy vystup PWM - perioda TMR2 = 256 (*4)
	MOVWF	PR2
	MOVLW	B'10000100' ; nastaveni prevodniku
	MOVWF	ADCON1
	banksel	ADCON0
	MOVLW	B'10000001'
	MOVWF	ADCON0

	CLRF	TMR2	; nastaveni PWM a vynulovani faze (TMR2)
	CLRF	CCPR1L	; kanal CCP1
	MOVLW	B'00001100'
	MOVWF	CCP1CON

	CLRF	HODNOTA+0
	CLRF	HODNOTA+1

OPAKUJ	CALL	STRIDA	; nastaveni stridy PWM podle 16bitove promenne HODNOTA

	MOVLW	D'3'	; provedeme A/D prevod na kanalu 3 (potenciometr P2)
	CALL	PREVOD
	banksel	ADRESH
	MOVF	ADRESH,W
	banksel	HODNOTA+1
	MOVWF	HODNOTA+1
	banksel	ADRESL
	MOVF	ADRESL,W
	banksel	HODNOTA+0
	MOVWF	HODNOTA+0

	GOTO	OPAKUJ	; opakujeme cely cyklus znovu

; realizace D/A prevodniku pomoci stridy PWM kanalu
;!! jako vstup se pouziva 16bitova promenna HODNOTA !!
STRIDA	RRF	HODNOTA+1,F
	RRF	HODNOTA+0,F
	BCF	CCP1CON,CCP1Y ; nasouvani nejnizsich bitu HODNOTA do CCP1Y a CCP1X
	BTFSC	STATUS,C
	BSF	CCP1CON,CCP1Y
	RRF	HODNOTA+1,F
	RRF	HODNOTA+0,W
	BCF	CCP1CON,CCP1X
	BTFSC	STATUS,C
	BSF	CCP1CON,CCP1X
	MOVWF	CCPR1L	; nastaveni hlavniho registru (pomoci HODNOTA+0)
	RETURN

	; A/D prevod
PREVOD	N_PREV	ADTEMP,ADRESL_,ADRESH_,AD_COUNT,D'0'

	END
